/*
 *  file      : src/wind_main.c
 *  project   : b2im
 *  copyright : (C) 2015 by BULIN Claude
 * 
 *  This file is part of b2im project
 * 
 *  b2im is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; version 3.
 * 
 *  b2im is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */


#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif
#include <gtk/gtk.h>
#include <glib.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_b2im/lib.h"
#endif

#include "global.h"
#include "configuser.h"


GtkBuilder	*GtkBuilderProjet_wind_main = NULL;
GtkWidget	*WindMain_wind_main = NULL;


void save_datas_config( void )
{
	g_print("\n--------------------------------------------------\n");
	PRINT_FUNC_LF();
	g_print("--------------------------------------------------\n");
	
	g_print("Recuperation position et taille de la fenetre\n");
	gdk_window_get_root_origin( gtk_widget_get_window(WindMain_wind_main), &Config.WinPos_X, &Config.WinPos_Y );
	Config.WinWidth  = gdk_window_get_width( gtk_widget_get_window(WindMain_wind_main) );
	Config.WinHeight = gdk_window_get_height( gtk_widget_get_window(WindMain_wind_main) ) ;
	// printf("x=%d\ny=%d\nwidth=%d\nheight=%d\n", Config.WinPos_X,Config.WinPos_Y,Config.WinWidth,Config.WinHeight );
	if( NULL != Config.string_choice_desktop ) {
		g_free( Config.string_choice_desktop );
		Config.string_choice_desktop = NULL;
	}
	Config.string_choice_desktop = g_strdup( NtbDesktop_get_desktop_actif() );
	
	if( TRUE == gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(GLADE_GET_OBJECT("radiobutton_iso_32_bits")) ))
		Config.choice_kernel_XX_bits = 32;
	else
		Config.choice_kernel_XX_bits = 64;
	Config.choice_type_image = gtk_combo_box_get_active( GTK_COMBO_BOX(GLADE_GET_OBJECT("combobox_type_image")) );

	Config.bool_import_picture = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(GLADE_GET_OBJECT("checkbutton_import_picture_to_gfxboot")));
	Config.choice_num_language = gtk_combo_box_get_active( GTK_COMBO_BOX(GLADE_GET_OBJECT("combobox_gfxboot_langue")) );
	
	if( Config.choice_num_image_boot > 19 ) Config.choice_num_image_boot = 0;
	g_print("Sauvegarde de la configuration\n");
	configuser_save();
	g_print("configuser_remove()\n");
	configuser_remove();
	
	g_print("NtbPackage_remove_list()\n");
	NtbPackage_remove_list();
}

gboolean on_wind_main_delete_event( GtkWidget *widget, GdkEvent *event, gpointer user_data )
{
	save_datas_config();
	gtk_main_quit();
	return( FALSE );
}

gboolean on_wind_main_destroy_event( GtkWidget *widget, GdkEvent *event, gpointer user_data )
{
	save_datas_config();
	gtk_main_quit();
	return( FALSE );
}

void on_imagemenuitem_quit_activate( GtkEntry *editable, gpointer data )
{
	save_datas_config();
	gtk_main_quit();
}

void on_imagemenuitem_help_activate( GtkEntry *editable, gpointer data )
{
	// printf( "on_imagemenuitem_help_activate\n" );
	wind_about_init( WindMain_wind_main );
}

// NOTEBOOK_INIT_PACKAGES
// 	Init packages
// 		test si 'Manjaro-tools' est installé
// 		test fichier de config
// 			/etc/manjaro-tools/manjaro-tools.conf	-> $HOME/.config/manjaro-tools.conf
// 		test destination des path depuis [ $HOME/.config/manjaro-tools.conf ]
// 			cache_dir=/home/cat/work/cache/manjaro-tools
// 			chroots_pkg=/home/cat/work/cache/buildpkg
// 			chroots_iso=/home/cat/work/cache/buildiso
// 		IF NOT [ $HOME/work/manjaro-tools/iso-profiles/ ]
// 			COPY [ /usr/share/manjaro-tools/iso-profiles/ ] to [ $HOME/work/manjaro-tools/iso-profiles/ ]		
void test_exist_and_config_manjaro_tools( void )
{
	gchar *txt = NULL;
	
	// les outils dans le systeme sont ils presents ?
	gtk_label_set_use_markup( GTK_LABEL(GLADE_GET_OBJECT("label_manjaro_tools")), TRUE );
	if( TRUE == g_file_test( "/usr/share/manjaro-tools", G_FILE_TEST_IS_DIR ))
			txt = g_strdup_printf("/usr/share/manjaro-tools/   <b>%s</b>", _("is present") );
	else	txt = g_strdup_printf("/usr/share/manjaro-tools/   <b>%s</b>", _("Not found") );
	gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_manjaro_tools")), txt );
	g_free( txt );
	txt = NULL;
	
	// "$HOME/.config/manjaro-tools.conf" is present ?
	// if( NULL == Config.pathname_manjaro_tools_iso_profiles )
	Config.pathname_manjaro_tools_iso_profiles = g_strdup_printf( "%s/.config/manjaro-tools.conf", Config.path_user );
	if( FALSE == g_file_test( Config.pathname_manjaro_tools_iso_profiles, G_FILE_TEST_EXISTS )) {
		
		GError	*error = NULL;
		GFile	*source = g_file_new_for_path("/etc/manjaro-tools/manjaro-tools.conf" );
		gchar	*path   = g_strdup_printf( "%s/.config/", Config.path_user );
		GFile	*dest   = g_file_new_for_path( path );

		g_file_copy( source, dest, G_FILE_COPY_NONE, NULL, NULL, NULL, &error );
		g_free( path );
		path = NULL;
	}
	txt = g_strdup_printf("%s   <b>%s</b>", Config.pathname_manjaro_tools_iso_profiles, _("is present") );
	gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_copy_to_config")), txt );
	g_free( txt );
	txt = NULL;
	
	// Choosing a place stokage iso files:
	gtk_button_set_label(
		GTK_BUTTON(GLADE_GET_OBJECT("button_stokage_iso_file")),
		// gtk_button_get_label( GTK_BUTTON(GLADE_GET_OBJECT("button_stokage_iso_file")) )
		Config.path_cache_iso
		);
	txt = g_strdup_printf( " = %s/cache/manjaro-tools\n = %s/cache/buildpkg\n = %s/cache/buildiso",
					// gtk_button_get_label( GTK_BUTTON(GLADE_GET_OBJECT("button_stokage_iso_file")) ),
					// gtk_button_get_label( GTK_BUTTON(GLADE_GET_OBJECT("button_stokage_iso_file")) ),
					// gtk_button_get_label( GTK_BUTTON(GLADE_GET_OBJECT("button_stokage_iso_file")) )
					Config.path_cache_iso,
					Config.path_cache_iso,
					Config.path_cache_iso
					 );
	gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_stokage_iso_file")), txt );
	g_free( txt );
	txt = NULL;
	
	// ou est est le dossier [ Manjaro-tools-iso-profiles ] ?.
	// printf("()-->Config.path_folder_manjaro_profiles = %s\n", Config.path_folder_manjaro_profiles );
	gtk_button_set_label( GTK_BUTTON(GLADE_GET_OBJECT("button_location_manjaro_profile")), Config.path_folder_manjaro_profiles );
	gtk_widget_set_sensitive(
			GTK_WIDGET(GLADE_GET_OBJECT("button_next")),
			NtbDesktop_is_ok( Config.path_folder_manjaro_profiles )
				);
}

void on_notebook_main_switch_page( GtkNotebook *notebook, gpointer page, guint page_num, gpointer user_data )
{
	// printf( "on_notebook_main_switch_page: %d\n", page_num );
	if( page_num == NOTEBOOK_INIT_PACKAGES ) {
		gtk_widget_hide( GTK_WIDGET(GLADE_GET_OBJECT("button_previous")) );
		gtk_widget_set_sensitive( GTK_WIDGET(GLADE_GET_OBJECT("button_previous")), FALSE );
		gtk_widget_show( GTK_WIDGET(GLADE_GET_OBJECT("button_next")) );
		gtk_widget_set_sensitive( GTK_WIDGET(GLADE_GET_OBJECT("button_next")), TRUE );
		// 
		test_exist_and_config_manjaro_tools();
	}
	else if( page_num == NOTEBOOK_GENERATE ) {
		gtk_widget_show( GTK_WIDGET(GLADE_GET_OBJECT("button_previous")) );
		gtk_widget_set_sensitive( GTK_WIDGET(GLADE_GET_OBJECT("button_previous")), TRUE );
		gtk_widget_hide( GTK_WIDGET(GLADE_GET_OBJECT("button_next")) );
		gtk_widget_set_sensitive( GTK_WIDGET(GLADE_GET_OBJECT("button_next")), FALSE );
		// 
		test_exist_and_config_manjaro_tools();
	}
	else {
		gtk_widget_show( GTK_WIDGET(GLADE_GET_OBJECT("button_previous")) );
		gtk_widget_set_sensitive( GTK_WIDGET(GLADE_GET_OBJECT("button_previous")), TRUE );
		gtk_widget_show( GTK_WIDGET(GLADE_GET_OBJECT("button_next")) );
		gtk_widget_set_sensitive( GTK_WIDGET(GLADE_GET_OBJECT("button_next")), TRUE );
	}
}

void action_from_button_next_previous( gint p_old_page, gint p_new_page )
{
	if( p_old_page == NOTEBOOK_INIT_PACKAGES && p_new_page == NOTEBOOK_DESKTOP ) {
			// self.make_radiobutton_desktop()
			// printf("action_from_button_next_previous\n" );
			NtbDesktop_make_radiobutton_desktop();
	}
	else if( NOTEBOOK_DESKTOP == p_old_page ) {
		if( NULL != Config.string_choice_desktop ) {
			g_free( Config.string_choice_desktop );
			Config.string_choice_desktop = NULL;
		}
		Config.string_choice_desktop = g_strdup( NtbDesktop_get_desktop_actif() );
		// printf("Config.string_choice_desktop = %s\n", Config.string_choice_desktop );
	}
	else if( NOTEBOOK_PACKAGE == p_new_page ) {
		NtbPackage_set_check();
	}
	else if( NOTEBOOK_GENERATE == p_new_page ) {
		gchar	*txt = NULL;
		
		txt = g_strdup_printf("<b>%s</b>", NtbDesktop_get_desktop_actif() );
		gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_desktop")), txt );
		g_free( txt ); txt = NULL;
	
		txt = g_strdup_printf("<b>%s</b>", gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(GLADE_GET_OBJECT("radiobutton_iso_32_bits"))) ? "32 bits" : "64 bits" );
		gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_image")), txt );
		g_free( txt ); txt = NULL;
		
		txt = g_strdup_printf("<b>%s</b>", gtk_combo_box_text_get_active_text( GTK_COMBO_BOX_TEXT(GLADE_GET_OBJECT("combobox_gfxboot_langue"))) );
		gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_language")), txt );
		g_free( txt ); txt = NULL;
		
		txt = g_strdup_printf("<b>%s</b>", gtk_combo_box_text_get_active_text( GTK_COMBO_BOX_TEXT(GLADE_GET_OBJECT("combobox_choice_kernel"))) );
		gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_kernel")), txt );
		g_free( txt ); txt = NULL;
		
		// txt = g_strdup_printf("<b>%s</b>", gtk_entry_get_text( GTK_ENTRY(GLADE_GET_OBJECT("entry_new_version_iso_image"))) );
		txt = g_strdup_printf("<b>%s</b>", NtbKernel_get_dist_release() );
		gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_version_img_iso")), txt );
		g_free( txt ); txt = NULL;
	}
	
}

void on_button_previous_clicked( GtkButton *button, gpointer user_data )
{
	gint	old_page;
	old_page = gtk_notebook_get_current_page( GTK_NOTEBOOK(GLADE_GET_OBJECT("notebook_main")) );
	if( old_page > 0 ) {
		gtk_notebook_set_current_page( GTK_NOTEBOOK(GLADE_GET_OBJECT("notebook_main")), old_page -1 );
		action_from_button_next_previous( old_page, old_page -1 );
	}
}

void on_button_next_clicked( GtkButton *button, gpointer user_data )
{
	gint	old_page;
	old_page = gtk_notebook_get_current_page( GTK_NOTEBOOK(GLADE_GET_OBJECT("notebook_main")) );
	if( old_page < NOTEBOOK_GENERATE ) {
		gtk_notebook_set_current_page( GTK_NOTEBOOK(GLADE_GET_OBJECT("notebook_main")), old_page +1 );
		action_from_button_next_previous( old_page, old_page +1 );
	}
}





gboolean wind_main_init( GtkWidget *FromWindMain )
{
	gchar	*PackageVersion = NULL;

	if( NULL == (GtkBuilderProjet_wind_main = Builder_open( "wind_main.glade", GtkBuilderProjet_wind_main ))) {
		return( EXIT_FAILURE );
	}
	// Add language support from glade file
	gtk_builder_set_translation_domain(  GtkBuilderProjet_wind_main, "wind_main" );
	gtk_builder_connect_signals( GtkBuilderProjet_wind_main, NULL );

	WindMain_wind_main = GTK_WIDGET( gtk_builder_get_object( GtkBuilderProjet_wind_main, "wind_main" ));

	if( NULL != FromWindMain ) {
		gtk_window_set_transient_for (GTK_WINDOW(WindMain_wind_main), GTK_WINDOW(FromWindMain));
		gtk_window_set_modal (GTK_WINDOW(WindMain_wind_main), TRUE);
	}
	// resize window
	gtk_window_resize(GTK_WINDOW(WindMain_wind_main), Config.WinWidth, Config.WinHeight);
	// place the window
	gtk_window_move(GTK_WINDOW(WindMain_wind_main), Config.WinPos_X, Config.WinPos_Y);
	// icon apply
	libutils_set_default_icone_to_win( WindMain_wind_main );

	// PackageVersion = g_strdup_printf( "%s  -  %s", PACKAGE_NAME, VERSION );
	PackageVersion = g_strdup_printf( "Build to ISO Manjaro  -  %s", VERSION );
	gtk_window_set_title( GTK_WINDOW( WindMain_wind_main ), PackageVersion );
	g_free( PackageVersion );
	PackageVersion = NULL;

	gtk_widget_show_all( WindMain_wind_main );

	return( TRUE );
}

